// All APIs
// OPTIN 1.7 CDO 5.3

var reopen = false;
var slideCount = 0;

function loaded()
{
    localizeHTMLTag("terms-button");
    localizeHTMLTag("slider3-header");
    localizeHTMLTag("slider3-description");
    localizeHTMLTag("slider4-header");
    localizeHTMLTag("slider4-description");
    localizeHTMLTag("slider5-header");
    localizeHTMLTag("slider5-description");
    localizeHTMLTag("slider5-description2");
    localizeHTMLTag("slider6-header");
    localizeHTMLTag("location-button");

	// Remove pages if permissions were handled
    handleMissingPermissions();

    if (calldoradoAccepted() || shouldSkipEULA()) {
        reopen = true;
        slide = document.getElementById("eula-slide");
        slide.parentNode.removeChild(slide);
        slideCount = 0;
        triggerAction(slideCount);
    }

    // Fetching app name
    var applicationName = getAppName();
    var applicationNameContainer = document.getElementsByClassName("app-name");
    for(var i = 0; i < applicationNameContainer.length; i++) {
        applicationNameContainer[i].innerText = applicationName;
    }

    // Fetching app icon
    if (getDeviceInfo().indexOf("cdoVersion") > -1 && getCdoVersion() >= 431) {
            document.getElementById("app-icon").src = "data:image/png;base64," + getAppIcon();
    }
    else document.getElementById("app-icon").style.display = 'none';

    // Special logic for kitkat devices
    var sdkInt = getDeviceInfo().slice(15,17);
    if (sdkInt <= 18) {
        slide = document.getElementById("thank-slide");
        slide.style.display = "none";

        // For Android 4.1 and earlier, remove custom checkboxes and use default instead
        var checkmarks = document.getElementsByClassName("checkmark");
        if (checkmarks.length > 0) {
            for (var i = 0; i < checkmarks.length; i++) {
                checkmarks[i].style.display = "none";
            }
            document.getElementById("privacy-policy-checkbox").style.opacity = "1";
            document.getElementById("privacy-policy-checkbox").style.position = "relative";
            document.getElementById("eula-checkbox").style.opacity = "1";
            document.getElementById("eula-checkbox").style.position = "relative";
        }
        var checkboxContainer = document.getElementsByClassName("fixed-bottom-button");
        if (checkboxContainer.length > 0) {
            checkboxContainer[0].style.position = "initial";
        }
    }

}

/*
*	Localization
*/

function localizeHTMLTag(tagId)
{
	tag = document.getElementById(tagId);
	var translation = getTranslation(tagId);
    if (tagId == "slider3-description") {
        var key = getTranslation("slider3-highlight");
        translation = translation.replace(key, "<u>"+ key +"</u>");
    }
	if (tag !== null) tag.innerHTML = translation;
}

/*
* 	Carousel 
*/

function goPrev() {
	var container = document.getElementById("slider-container");
	if (slideCount > 0) {
		slideCount--;
		container.style.transform = "translateX(-" + (slideCount * window.innerWidth) + "px)";
	}
}

function goNext(toSlide) {
	var container = document.getElementById("slider-container");
	var slides = document.getElementsByClassName("slider-item");

	// Only slide to next, if next slide exists
	if (slideCount <= (slides.length - 1)) {
		if (toSlide === undefined)
			slideCount++;
		else
			slideCount = toSlide;

		container.style.transform = "translateX(-" + (slideCount * window.innerWidth) + "px)";

		triggerAction(slideCount);
	}
}

function triggerAction(slideCount) {
	var slide = document.getElementsByClassName("slider-item")[slideCount];
	var permissionNumber = slide.getAttribute("data-permission");
	// showToast("slideCount " + slideCount + " permissionNumber " + permissionNumber);

	if (permissionNumber == 1) {
		setTimeout(function () {
			requestPermissionGroup("phone");
		}, 1000);
	}
	if (permissionNumber == 2) {
		setTimeout(function () {
			requestPermissionGroup("contacts");
		}, 1000);
	}
	if (permissionNumber == 3) {
	    if(!(cuebiqShouldBeEnabled())) {
	        setTimeout(function () {
                requestPermissionGroup("location");
            }, 1000);
	    }
	}
	if (permissionNumber == 4) {
		if (reopen) {
			sendCompletionStats();
			closeWebOptin();
		} 
		else {
			setTimeout(function () {
				sendCompletionStats();
				closeWebOptin();
			}, 1000);
		}
		if (permissionsWereHandled()) {
			showOptinAgain(false);
		}
	}
}

function setLockTimePerPage(slideCount) {
	if (slideCount == 0) setLockTime(0);
	if (slideCount == 1) setLockTime(0);
	if (slideCount == 2) setLockTime(0);
	if (slideCount == 3) setLockTime(0);
	if (slideCount == 4) setLockTime(0);
	if (slideCount == 5) setLockTime(0);
}

function requestPermissionGroup(group) {
	var list = [];
	
	if (group == "phone") {
		list = 
			["android.permission.READ_CALL_LOG",
			 "android.permission.READ_PHONE_STATE",
			 "android.permission.CALL_PHONE",
             "android.permission.ANSWER_PHONE_CALLS"];
	}
	if (group == "contacts") {
		list = 
			["android.permission.WRITE_CONTACTS", 
			 "android.permission.READ_CONTACTS"];
	}
	if (group == "location") {
		list = 
			["android.permission.ACCESS_COARSE_LOCATION", 
			 "android.permission.ACCESS_FINE_LOCATION"];
	}
	
	requestPermissions(list);
}

function isAllConsentChecked() {
	var privacyCheckbox = false, eulaCheckbox = false;

	if (document.getElementById("privacy-policy-checkbox") !== null) {
		privacyCheckbox = document.getElementById("privacy-policy-checkbox").checked;
	}
	if (document.getElementById("eula-checkbox") !== null) {
		eulaCheckbox = document.getElementById("eula-checkbox").checked;
	}

	return privacyCheckbox && eulaCheckbox;
}

function toggleEulaConsent() {
	var btn = document.getElementById("terms-button-eea");

	// Check for all consents are checked in the eula-slide
	if (isAllConsentChecked()) {
		btn.classList.add("active");
	} else {
		btn.classList.remove("active");
	}
}

function agree() {
	var checkboxChecked = true;
	if (document.getElementById("eula-checkbox") != null) {
		checkboxChecked = isAllConsentChecked();
	}
	if (checkboxChecked) {
		goNext();
		acceptCalldorado(true);
        acceptConditions(["eula", "privacy"], [true, true]);
        sendStats("optin_web_eula_accepted", "");
	}
}

function handleMissingPermissions() {

    if (cuebiqShouldBeEnabled()) {
            slide = document.getElementById("default");
            if (slide != null) slide.style.display = "none";
        }
        else {
            slide = document.getElementById("cuebiq");
            if (slide != null) slide.style.display = "none";
            document.getElementById("location-button").style.display = "none";
        }
	
	var targetSdk = getDeviceInfo().slice(28,30);
	
	if (getPermissionStatus("android.permission.ACCESS_COARSE_LOCATION") == '1' && targetSdk >= 23) {
		// slideCount = 2;
	}
	else {
		var slide = document.getElementById("location-slide");
		slide.parentNode.removeChild(slide);
	}
	
	if (getPermissionStatus("android.permission.WRITE_CONTACTS") == '1' && targetSdk >= 23) {
		// slideCount = 1;
	}
	else {
		var slide = document.getElementById("contacts-slide");
		slide.parentNode.removeChild(slide);
	}
	
	if (targetSdk >= 23 &&
	    (getPermissionStatus("android.permission.READ_CALL_LOG") == '1' ||
	        getPermissionStatus("android.permission.READ_PHONE_STATE") == '1')) {
		// slideCount = 0;
	} 
	else {
		var slide = document.getElementById("phone-slide");
		slide.parentNode.removeChild(slide);
	}
}

function sendCompletionStats() {
	
	var sdkInt = getDeviceInfo().slice(15,17);
	var targetSdk = getDeviceInfo().slice(28,30);
	
	if (sdkInt >= 23 && targetSdk >= 23) {
	
		var statusList = "";
		var list = ["android.permission.READ_PHONE_STATE", 
					"android.permission.WRITE_CONTACTS", 
					"android.permission.ACCESS_COARSE_LOCATION"];
        //Call log permission is added for Android Pie
		if (sdkInt >= 28) {
		    var list = ["android.permission.READ_CALL_LOG", "android.permission.READ_PHONE_STATE",
            					"android.permission.WRITE_CONTACTS",
            					"android.permission.ACCESS_COARSE_LOCATION"];

		}

		for (i = 0; i < list.length; i++) {
			statusList = statusList + getPermissionStatus(list[i]);
		}

		if (sdkInt >= 28) {
		    if (statusList == "0000") {
            			sendStats("optin_web_complete_success", "");
            		}
            		else if (statusList == "2222") {
            			sendStats("optin_web_complete_failed", "");
            		}
            		else {
            			sendStats("optin_web_complete_partial", "");
            		}

		} else {
		    if (statusList == "000") {
            			sendStats("optin_web_complete_success", "");
            		}
            		else if (statusList == "222") {
            			sendStats("optin_web_complete_failed", "");
            		}
            		else {
            			sendStats("optin_web_complete_partial", "");
            		}
		}

	}
}

/*
* 	WEB API FOR ANDROID CLIENT 
*/

/**
 * Called when the client responds to permissions
 * @param key - permission name (string)
 * @param value - permission status (int): 0 for granted, 1 for denied and 2 for never ask again
 */
function permissionCallback(key, value) {
	if(value == 0 || value == 2) {
		if (permissionsWereHandled()) {
			showOptinAgain(false);
		}
	}
	goNext();
}

/** 
 * Called when the client responds to the dialog from showDialog(...)
 * @param result - true if response is positive, false otherwise
 */
function dialogResponse(result) {
	// TODO
	showToast("Result = " + result);
}